# List Sites

> Infra API · Sites

```http
GET https://app.mk.io/api/v1/projects/{project_name}/infra/sites
```

List sites on the specified project. To learn more about sites, read [Site Concept](ref:infrastructure-api#site-concept).

## Listing, Sorting and Filtering Sites

This endpoint returns the list of sites in the specified project.

### Sorting

The results from this endpoint can be ordered using the `$orderby` query parameter. Specify a list of field names, separated by commas
where each one can optionally specify `asc` or `desc`.

Sorting is valid on the following fields: `created`, `createdBy`, `displayName`, `id`, `labels`, `metadata/name`, `name`, `status/owner`, `updated`, `updatedBy`

### Filtering

There are two ways to filter the set of returned sites from this endpoint - the first is to use the `$filter` query parameter, the second is to use the
`$label_key` and `$label` query parameters.

The `$filter` query parameter allows for sites to be filtered on the basis of fields in the schema using OData query syntax.
See [this document](https://learn.microsoft.com/en-us/odata/concepts/queryoptions-overview#filter) for more details on the syntax used.

Filters are valid on the following fields: `created`, `createdBy`, `createdByEmail`, `createdByName`, `displayName`, `id`, `labels`, `metadata/name`, `name`, `status/locationName`, `status/owner`, `updated`, `updatedBy`, `updatedByEmail`, `updatedByName`

`$label_key` and `$label` are specific to querying sites based on their labels. Labels are a set of key-value pairs that can be used to identify sites with
any arbitrary metadata you want, specifically for the purpose of retrieving relevant subsets of sites.

### Examples:

`?$top=10` - Returns only the first 10 sites from the list.

`?$orderby=name desc` - Sorts sites by name in descending order.

`?$filter=name eq 'descriptive name'` - Returns sites that match the provided name.

`?$orderby=created desc` - Sorts sites by creation date in descending order.

`?$filter=created ge 2021-01-01T00:00:00Z` - Returns sites created after January 1, 2021.

`?$label=studio=paravalley` - Returns sites with the label `studio` set to `paravalley`.

`?$label=release-date~2023` - Returns sites with the label `release-date` set to a value that contains `2023`.

`?$label_key=studio&label_key=release-date` - Returns sites with any value set for the `studio` label and the `release-date` label.

RBAC Capability Required: `infra.site.get`

## Authentication

- `Authorization` header — Bearer authentication of the form `Bearer <token>`.

## Path parameters

| Name | Type | Required | Description |
| --- | --- | --- | --- |
| `project_name` | string | Yes | — |

## Query parameters

| Name | Type | Required | Description |
| --- | --- | --- | --- |
| `$orderby` | string | No | Specifies the key by which the result collection should be ordered. |
| `$filter` | string | No | Restricts the set of items returned. |
| `$top` | string | No | Specifies a non-negative integer `n` that limits the number of items returned from a collection. The service returns the number of available items up to but not greater than the specified value `n`. |
| `$skiptoken` | string | No | Specifies a start offset to support paginated results. Use `@odata.nextLink` in the result object to enumerate the collection - it will be present only if there's more than one page of entities. |
| `$label_key` | string | No | Filters the set to the specified label key. If multiple $label_keys are specified, matching items must have all labels. |
| `$label` | string | No | Filters the set to the specified label key/value pair. Supports equality, inequality, and inexact matching. If multiple values are provided for the same key, items matching either value will be returned. |

## Example request

```bash
curl -X GET "https://app.mk.io/api/v1/projects/{project_name}/infra/sites" \
  -H "Authorization: Bearer <token>"
```

## Responses

### 200 — A list of sites

- `@odata.nextLink` · string · Optional — @odata.nextLink URL if the page length and number of items match.
- `supplemental` · object · **Required** — Supplemental info
  - `count` · integer · **Required** — Number of items returned
  - `kind` · string · **Required** — Type of items in the list
  - `operation` · string · **Required** — Operation type. Should always say 'list'
  - `pagination` · object · **Required** — Pagination info
    - `end` · integer · **Required** — Position of the last item in the list
    - `records` · integer · **Required** — Total number of items returned in the list
    - `start` · integer · **Required** — Position of the first item in the list
    - `total` · integer · **Required** — Total number of items in the project
  - `subscription` · object · Optional — Project info
    - `id` · string · **Required** — Project ID
    - `name` · string · **Required** — Project name
- `value` · list of objects · **Required** — A list of sites.
  - Array items (object):
    - `kind` · string · **Required** — The kind of record.
    - `metadata` · object · **Required** — Site metadata.
      - `created` · string · Optional · _format: date-time_ — The time when the resource was created
      - `createdBy` · string · Optional · _format: uuid_ — ID of the user who created the resource
      - `createdByEmail` · string · Optional — Email of the user who created the resource
      - `displayName` · string · Optional — The display name of the resource
      - `id` · string · **Required** · _format: uuid_ — The ID of the resource
      - `labels` · map from strings to string · Optional — A dictionary of labels associated with the resource
        - `[any key]` · string — map of additional properties
      - `name` · string · Optional — The name of the resource
      - `updated` · string · Optional · _format: date-time_ — The time when the resource was last updated
      - `updatedBy` · string · Optional · _format: uuid_ — ID of the user who last updated the resource
      - `updatedByEmail` · string · Optional — Email of the user who last updated the resource
    - `spec` · object · **Required** — Site specification.
      - `geolocation` · object · Optional — Optional geolocation data for the site.
        - `coordinates` · list of doubles · **Required** · _0-2 items_ — Co-ordinates that describe the geolocation (ISO 6709), an array of two floating point numbers [latitude(North - South), longitude(East - West)]. Set an empty array to clear the geolocation.
          - Array items (double):
      - `routes` · list of objects · Optional — The routes that connect the network to <<glossary:site>>s.
        - Array items (object):
          - `defaultTransport` · object · Optional — Settings used to influence the <<glossary:transport>> that the system will automatically select when it needs to send <<glossary:content>> from one <<glossary:flow>> to another flow. The default transport settings from the route on which the content enters the network are used to select and configure the transport for the content. Read [Default transports](ref:infrastructure-api#default-transports) to learn more.
            - `cidr` · string · Optional · _Defaults to _ — The IP address range to choose from when the system automatically creates transport settings for sending content from one flow to another. If a specific IP/URL (such as a public cloud IP or a fleet device IP) is required to send content between flows, then this setting will be ignored.
            - `type` · enum · **Required** — The type of <<glossary:transport>> to use for sending content from one flow to another flow.
              - Allowed values: `Auto`, `SRTListener`, `SRTCaller`, `UDP`, `RISTListener`
          - `networkName` · string · **Required** · _pattern: ^[a-z0-9]([a-z0-9-]{0,61}[a-z0-9])?$_ — The name of the <<glossary:network>> connected to the site by this route.
    - `status` · object · **Required** — Site status.
      - `locationDisplayName` · string · Optional · _<=255 characters_ — Display name of the location of this site. This field is only relevant for <<glossary:SaaS site>>s. To learn more, read [Sites](ref:infrastructure-api#site-concept).
      - `locationName` · string · Optional · _pattern: ^[a-z0-9]([a-z0-9-]{0,61}[a-z0-9])?$_ — Name of the location of this site. This field is only relevant for <<glossary:SaaS site>>s. To learn more, read [Sites](ref:infrastructure-api#site-concept).
      - `owner` · enum · **Required** — Indicates whether the site was automatically created by the system. System owned sites cannot be deleted, but they can be modified. To learn more, read [System owned sites](ref:infrastructure-api#system-owned-sites).
        - Allowed values: `User`, `System`

Example:

```json
{
  "@odata.nextLink": "string",
  "supplemental": {
    "count": 0,
    "kind": "string",
    "operation": "string",
    "pagination": {
      "end": 0,
      "records": 0,
      "start": 0,
      "total": 0
    },
    "subscription": {
      "id": "string",
      "name": "string"
    }
  },
  "value": [
    {
      "kind": "string",
      "metadata": {
        "created": "2024-01-01T00:00:00Z",
        "createdBy": "00000000-0000-0000-0000-000000000000",
        "createdByEmail": "string",
        "displayName": "string",
        "id": "00000000-0000-0000-0000-000000000000",
        "labels": {
          "label1": "value1",
          "label2": "value2"
        },
        "name": "string",
        "updated": "2024-01-01T00:00:00Z",
        "updatedBy": "00000000-0000-0000-0000-000000000000",
        "updatedByEmail": "string"
      },
      "spec": {
        "geolocation": {
          "coordinates": [
            0
          ]
        },
        "routes": [
          {
            "defaultTransport": {
              "cidr": "239.0.0.1/24",
              "type": "UDP"
            },
            "networkName": "internet"
          }
        ]
      },
      "status": {
        "locationDisplayName": "string",
        "locationName": "string",
        "owner": "User"
      }
    }
  ]
}
```

### 400 — Bad Request

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 401 — Unauthorized

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 403 — Forbidden

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 404 — Not Found

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 429 — Too Many Requests

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 500 — Internal Server Error

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

---

Source spec: `infrastructure-api` · operationId: `[get]_/api/v1/projects/{project_name}/infra/sites`
